%This Example for using users m-function Optimization_subroutine.m was created automatically by PSG Toolbox.

%Function description:

%minimize
%variance(matrix_scenarios)
%Constraint: <= parameter_bound
%1.0001*linear(matrix_linear)
%+0.0001*cardn_pos(parameter_alpha, matrix_linear_card)
%Constraint: <= parameter_bound_1
%cardn_pos(parameter_alpha_1, matrix_linear_card)
%-variable(u)
%Constraint: >= parameter_bound_2
%avg_g(matrix_scenarios)
%-0.0001*linear(matrix_linear)
%-0.0001*cardn_pos(parameter_alpha_2, matrix_linear_card)
%Constraint: <= parameter_bound_3
%pr_pen(parameter_alpha_3,matrix_probability)
%Box: >= parameter_bound_4, <= point_upperbounds
%
%
%Input variables:
%
%Inputs                     PSG Type    PSG Object            Location in Problem Statement                               Class
%matrix_scenarios_data      data        matrix_scenarios      variance(matrix_scenarios)                                  double
%                                                             avg_g(matrix_scenarios)
%matrix_scenarios_vars      vars        matrix_scenarios      variance(matrix_scenarios)                                  cell
%                                                             avg_g(matrix_scenarios)
%matrix_linear_data         data        matrix_linear         1.0001*linear(matrix_linear)                                double
%                                                             +0.0001*cardn_pos(parameter_alpha, matrix_linear_card)
%                                                             cardn_pos(parameter_alpha_1, matrix_linear_card)
%                                                             -0.0001*linear(matrix_linear)
%                                                             -0.0001*cardn_pos(parameter_alpha_2, matrix_linear_card)
%matrix_linear_vars         vars        matrix_linear         1.0001*linear(matrix_linear)                                cell
%                                                             +0.0001*cardn_pos(parameter_alpha, matrix_linear_card)
%                                                             cardn_pos(parameter_alpha_1, matrix_linear_card)
%                                                             -0.0001*linear(matrix_linear)
%                                                             -0.0001*cardn_pos(parameter_alpha_2, matrix_linear_card)
%matrix_linear_card_data    data        matrix_linear_card    +0.0001*cardn_pos(parameter_alpha, matrix_linear_card)      double
%                                                             cardn_pos(parameter_alpha_1, matrix_linear_card)
%                                                             -0.0001*cardn_pos(parameter_alpha_2, matrix_linear_card)
%matrix_linear_card_vars    vars        matrix_linear_card    +0.0001*cardn_pos(parameter_alpha, matrix_linear_card)      cell
%                                                             cardn_pos(parameter_alpha_1, matrix_linear_card)
%                                                             -0.0001*cardn_pos(parameter_alpha_2, matrix_linear_card)
%matrix_probability_data    data        matrix_probability    pr_pen(parameter_alpha_3,matrix_probability)                double
%matrix_probability_vars    vars        matrix_probability    pr_pen(parameter_alpha_3,matrix_probability)                cell
%point_upperbounds_data     data        point_upperbounds     Box: >= parameter_bound_4, <= point_upperbounds             double
%point_upperbounds_vars     vars        point_upperbounds     Box: >= parameter_bound_4, <= point_upperbounds             cell
%parameter_bound_data       data        parameter_bound       Constraint: <= parameter_bound                              double
%parameter_alpha_data       data        parameter_alpha       +0.0001*cardn_pos(parameter_alpha, matrix_linear_card)      double
%parameter_bound_1_data     data        parameter_bound_1     Constraint: <= parameter_bound_1                            double
%parameter_alpha_1_data     data        parameter_alpha_1     cardn_pos(parameter_alpha_1, matrix_linear_card)            double
%parameter_bound_2_data     data        parameter_bound_2     Constraint: >= parameter_bound_2                            double
%parameter_alpha_2_data     data        parameter_alpha_2     -0.0001*cardn_pos(parameter_alpha_2, matrix_linear_card)    double
%parameter_bound_3_data     data        parameter_bound_3     Constraint: <= parameter_bound_3                            double
%parameter_alpha_3_data     data        parameter_alpha_3     pr_pen(parameter_alpha_3,matrix_probability)                double
%parameter_bound_4_data     data        parameter_bound_4     Box: >= parameter_bound_4, <= point_upperbounds             double
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


%Load data from mat-file:
load('D:\American Optimal Decisions\PSG\MATLAB_Stan\ready\Portfolio Optimization with Probabilistic Constraint\data_problem_spm_cardinality_integer_2_100__short\Optimization_subroutine_data.mat')

%Save variables from mat-file to Workspace:
tbpsg_export_to_workspace(toolboxstruc_arr)

%Run users m-function Optimization_subroutine:

[solution_str,outargstruc_arr] = Optimization_subroutine(matrix_scenarios_data,matrix_scenarios_vars,matrix_linear_data,matrix_linear_vars,matrix_linear_card_data,matrix_linear_card_vars,matrix_probability_data,matrix_probability_vars,point_upperbounds_data,point_upperbounds_vars,parameter_bound_data,parameter_alpha_data,parameter_bound_1_data,parameter_alpha_1_data,parameter_bound_2_data,parameter_alpha_2_data,parameter_bound_3_data,parameter_alpha_3_data,parameter_bound_4_data);

%Extract Objective:
val_obj = tbpsg_objective(solution_str, outargstruc_arr);

disp(' ');
disp('Objective = ');
disp(val_obj);

%Extract optimal solution:
point_data = tbpsg_optimal_point_data(solution_str, outargstruc_arr);

disp(' ');
disp('Optimal point = ');
disp(point_data);

%Extract structure containing PSG solution reports:
output_structure = tbpsg_solution_struct(solution_str, outargstruc_arr);

disp(' ');
disp('Structure with PSG solution = ');
disp(output_structure);

%Uncomment the following lines to extract solutions details:

%output = tbpsg_isoptimal(solution_str, outargstruc_arr);

%output = tbpsg_function_data(solution_str, outargstruc_arr);

%output = tbpsg_function_names(solution_str, outargstruc_arr);

%output = tbpsg_time(solution_str, outargstruc_arr);

%output = tbpsg_optimal_point_vars(solution_str, outargstruc_arr);

%output = tbpsg_constraints_vars(solution_str, outargstruc_arr);

%output = tbpsg_slack_data(solution_str, outargstruc_arr);

%output = tbpsg_dual_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_constraint_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_dual_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_slack_data(solution_str, outargstruc_arr);

%output = tbpsg_matrix_data(solution_str, outargstruc_arr);

%output = tbpsg_matrix_vars(solution_str, outargstruc_arr);

%output = tbpsg_vector_data(solution_str, outargstruc_arr);

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 
